diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index 3c24eb1be..bd0ea8cdb 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1121,7 +1121,6 @@ public class Minecraft
                         }
                     }
                     sndManager.setMuted(gameSettings.muteOnLostFocus.value && !gameWindow.isFocused());
-                    guiToasts.render(timer.partialTicks);
 
                     switch (downloadResourcesThread.downloading) {
                         case DOWNLOADING: {
@@ -1657,6 +1656,7 @@ public class Minecraft
                         }
                     }
                 }
+                thePlayer.input.keyEvent(-1, Mouse.getEventButton(), Mouse.getEventButtonState());
             }
             if (toggleFlyPressed && !gameSettings.keyFly.isPressed())
             {
@@ -1681,7 +1681,7 @@ public class Minecraft
                 //Fix your keyboard Mak you broke the overlay toggle
                 boolean control = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL) /* || Keyboard.isKeyDown(Keyboard.KEY_F4)*/;
                 if(!(Keyboard.getEventKeyState() && gameSettings.keyToggleDebug.isPressed())) {
-                	thePlayer.input.keyEvent(Keyboard.getEventKey(), Keyboard.getEventKeyState());
+                	thePlayer.input.keyEvent(Keyboard.getEventKey(), -1, Keyboard.getEventKeyState());
                 }
                 
                 if(gameSettings.keyToggleDebug.isPressEvent()) {
@@ -2716,8 +2716,10 @@ public class Minecraft
         Minecraft mc = new Minecraft(mcDataDir == null ? getAppDir("minecraft-bta"): mcDataDir, gameWindow,false);
         mc.minecraftUri = "www.minecraft.net";
 
+        username = username == null ? "Player" + System.currentTimeMillis() % 1000L : username;
+
         sessionId = sessionId == null ? "" : sessionId;
-        if (uuid == null) {
+        if (uuid == null || !UUIDHelper.isUUID(uuid)) {
             if (username != null) {
                 UUID nameUUID = UUIDHelper.getUUIDFromName(username);
                 if (nameUUID != null) {
@@ -2728,7 +2730,6 @@ public class Minecraft
                 uuid = "00000000-0000-0000-0000-000000000000";
             }
         }
-        username = username == null ? "Player" + System.currentTimeMillis() % 1000L : username;
 
         mc.session = new Session(username, uuid, sessionId);
         if (server != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/enums/MusicFrequency.java b/game/client/src/main/java/net/minecraft/client/enums/MusicFrequency.java
new file mode 100644
index 000000000..f10ae9c1f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/enums/MusicFrequency.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.enums;
+
+import net.minecraft.core.util.helper.ITranslatable;
+
+public enum MusicFrequency
+    implements ITranslatable
+{
+    CONTINUOUS(0),
+    FREQUENT(3000),
+    DEFAULT(6000),
+    UNUSUAL(12000),
+    RARE(24000);
+
+    public final int interval;
+
+    MusicFrequency(final int interval) {
+        this.interval = interval;
+    }
+
+    @Override
+    public String getTranslationKey() {
+        return name().toLowerCase();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index a32f30efb..a3936a5b1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -20,11 +20,13 @@ import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.HudIngameDoom;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.Version;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
@@ -369,9 +371,9 @@ public class ScreenMainMenu extends Screen
         if(this.logoBlocks == null) {
             this.logoBlocks = new LogoBlock[logoBlockLayers[0].length()][logoBlockLayers.length];
 
-            for(int var2 = 0; var2 < this.logoBlocks.length; ++var2) {
-                for(var3 = 0; var3 < this.logoBlocks[var2].length; ++var3) {
-                    this.logoBlocks[var2][var3] = new LogoBlock(var2, var3);
+            for(int x = 0; x < this.logoBlocks.length; ++x) {
+                for(int y = 0; y < this.logoBlocks[x].length; ++y) {
+                    this.logoBlocks[x][y] = new LogoBlock(x, y);
                 }
             }
         }
@@ -527,8 +529,8 @@ public class ScreenMainMenu extends Screen
         public double prevHeight;
         public double dropSpeed;
 
-        public LogoBlock(int var2, int var3) {
-            this.height = this.prevHeight = (double)(10 + var3) + rand.nextDouble() * 32.0D + (double)var2;
+        public LogoBlock(int x, int y) {
+            this.height = this.prevHeight = (double)(10 + y) + rand.nextDouble() * 32.0D + (double)x;
         }
 
         public void updateLogoEffects() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 00c69d41a..3bccdbba2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -14,13 +14,14 @@ import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.PacketSignUpdate;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
 public class ScreenSignEditor extends Screen
 {
     private boolean inKeyboard = false;
-    public ScreenSignEditor(TileEntitySign sign)
+    public ScreenSignEditor(@NotNull TileEntitySign sign)
     {
         screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
         editLine = 0;
@@ -44,7 +45,10 @@ public class ScreenSignEditor extends Screen
         buttons.add(new ButtonElement(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
         buttons.add(new ButtonElement(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
 
-        boolean wallSign = !((BlockLogicSign) block.getLogic()).isFreeStanding;
+        boolean wallSign = false;
+        if (Block.hasLogicClass(block, BlockLogicSign.class)) {
+            wallSign = !((BlockLogicSign) block.getLogic()).isFreeStanding;
+        }
 
         add(new ListenerButtonElement(30, width/2 - 50, 12 * 0 + 67 + (wallSign ? 31 : 0), 100, 12, "")
             .setActionListener(() -> {editLine = 0; inKeyboard = true;})).mute().hide();
@@ -161,30 +165,34 @@ public class ScreenSignEditor extends Screen
         GL11.glScalef(-scale, -scale, -scale);
         GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
         Block<?> block = entitySign.getBlock();
-        if(((BlockLogicSign) block.getLogic()).isFreeStanding)
-        {
-            float signAngle = (float)((entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
-            GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
-        } else
-        {
-            int meta = entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE;
-            float signAngle = 0.0F;
-            if(meta == 2)
+        if (Block.hasLogicClass(block, BlockLogicSign.class)) {
+            BlockLogicSign sign = (BlockLogicSign) block.getLogic();
+            if(sign.isFreeStanding)
             {
-                signAngle = 180F;
-            }
-            if(meta == 4)
+                float signAngle = (float)((entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
+                GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
+                GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
+            } else
             {
-                signAngle = 90F;
+                int meta = entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE;
+                float signAngle = 0.0F;
+                if(meta == 2)
+                {
+                    signAngle = 180F;
+                }
+                if(meta == 4)
+                {
+                    signAngle = 90F;
+                }
+                if(meta == 5)
+                {
+                    signAngle = -90F;
+                }
+                GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
+                GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
             }
-            if(meta == 5)
-            {
-                signAngle = -90F;
-            }
-            GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
-            GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
         }
+
         if((updateCounter / 6) % 2 == 0)
         {
             entitySign.lineBeingEdited = editLine;
@@ -212,7 +220,7 @@ public class ScreenSignEditor extends Screen
     }
 
     protected String screenTitle;
-    private TileEntitySign entitySign;
+    private final @NotNull TileEntitySign entitySign;
     private int updateCounter;
     private int editLine;
     private int yOffset = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index ab11bcba0..1591c2e7c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -157,13 +157,23 @@ public abstract class ScreenContainerAbstract extends Screen
 	@Override
 	public void keyPressed(final char eventCharacter, final int eventKey, int mx, int my)
 	{
-		if (eventKey == Keyboard.KEY_ESCAPE || mc.gameSettings.keyInventory.isKeyboardKey(eventKey) || eventKey == Keyboard.KEY_BACK)
+		if (eventKey == Keyboard.KEY_ESCAPE || eventKey == Keyboard.KEY_BACK)
 		{
 			mc.thePlayer.closeScreen();
 		}
 		int slotId = getSlotId(mx, my);
+		checkKeybind(slotId, eventKey, -1);
+	}
+
+	public boolean checkKeybind(int slotId, int key, int mouseButton) {
+		boolean cancelClick = false;
+		if (mc.gameSettings.keyInventory.isKeyOrMouse(key, mouseButton))
+		{
+			mc.thePlayer.closeScreen();
+			cancelClick = true;
+		}
 		if(slotId >= 0) {
-			if(mc.gameSettings.keyShowRecipe.isKeyboardKey(eventKey)){
+			if(mc.gameSettings.keyShowRecipe.isKeyOrMouse(key, mouseButton)){
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()){
 					String query = "r:"+slot.getItemStack().getDisplayName()+"!";
@@ -172,9 +182,9 @@ public abstract class ScreenContainerAbstract extends Screen
 					GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
 					GuidebookPageSearch.searchField.setText(query);
 					ScreenGuidebook.getPageManager().updatePages();
-                    if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+					if (!((SearchableGuidebookSection) GuidebookSections.CRAFTING).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
 						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
-                    } else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
+					} else if (!((SearchableGuidebookSection) GuidebookSections.FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
 						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.FURNACE), true);
 					} else if (!((SearchableGuidebookSection) GuidebookSections.BLAST_FURNACE).searchPages(GuidebookPageManager.searchQuery).isEmpty()) {
 						ScreenGuidebook.getPageManager().setCurrentPage(ScreenGuidebook.getPageManager().getSectionIndex(GuidebookSections.BLAST_FURNACE), true);
@@ -183,8 +193,9 @@ public abstract class ScreenContainerAbstract extends Screen
 					}
 					mc.thePlayer.displayGuidebookScreen();
 				}
+				cancelClick = true;
 			}
-			if(mc.gameSettings.keyShowUsage.isKeyboardKey(eventKey)){
+			if(mc.gameSettings.keyShowUsage.isKeyOrMouse(key, mouseButton)){
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()) {
 					String query = "u:" + slot.getItemStack().getDisplayName() + "!";
@@ -204,54 +215,69 @@ public abstract class ScreenContainerAbstract extends Screen
 					}
 					mc.thePlayer.displayGuidebookScreen();
 				}
+				cancelClick = true;
 			}
-			if(mc.gameSettings.keyDrop.isKeyboardKey(eventKey)) {
+			if(mc.gameSettings.keyDrop.isKeyOrMouse(key, mouseButton)) {
 				boolean ctrl = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
 				int amount = 1;
 				if(ctrl) amount = 64;
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.DROP, new int[] {slotId, amount}, mc.thePlayer);
+				cancelClick = true;
 			}
 			// Horrifying
-			if (mc.gameSettings.keyHotBarSlot1.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot1.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 1}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot2.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot2.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 2}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot3.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot3.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 3}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot4.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot4.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 4}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot5.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot5.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 5}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot6.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot6.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 6}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot7.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot7.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 7}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot8.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot8.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 8}, mc.thePlayer);
+				cancelClick = true;
 			}
-			if (mc.gameSettings.keyHotBarSlot9.isKeyboardKey(eventKey)){
+			if (mc.gameSettings.keyHotBarSlot9.isKeyOrMouse(key, mouseButton)){
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.HOTBAR_ITEM_SWAP, new int[] {slotId, 9}, mc.thePlayer);
+				cancelClick = true;
 			}
 
-			if(mc.gameSettings.keySortInventory.isKeyboardKey(eventKey)) {
+			if(mc.gameSettings.keySortInventory.isKeyOrMouse(key, mouseButton)) {
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId}, mc.thePlayer);
+				cancelClick = true;
 			}
 		}
-		if (mc.currentScreen == this && mc.gameSettings.keyGuidebook.isKeyboardKey(eventKey)) {
+		if (mc.currentScreen == this && mc.gameSettings.keyGuidebook.isKeyOrMouse(key, mouseButton)) {
 			mc.thePlayer.displayGuidebookScreen();
+			cancelClick = true;
 		}
+		return cancelClick;
 	}
 
 	@Override
 	public void mouseClicked(final int mx, final int my, int buttonNum)
 	{
+		if (checkKeybind(getSlotId(mx, my), -1, buttonNum)) return;
 		super.mouseClicked(mx, my, buttonNum);
 		if(mc.gameSettings.enableItemDragging.value) {
 			itemDragHandler.mouseEvent(mx, my, buttonNum, true);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterMapDuplication.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterMapDuplication.java
index 7b5e6951f..8c1353073 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterMapDuplication.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterMapDuplication.java
@@ -18,7 +18,7 @@ public class DisplayAdapterMapDuplication implements RecipeDisplayAdapter<Recipe
         initMap.getData().putBoolean("initialized", true);
         ItemStack initMapX2 = new ItemStack(initMap);
         initMapX2.stackSize = 2;
-        RecipeSymbol[] symbols = {new RecipeSymbol(initMap), new RecipeSymbol(Items.MAP.getDefaultStack()), null, null, new RecipeSymbol(initMapX2)};
+        RecipeSymbol[] symbols = {new RecipeSymbol(initMap), new RecipeSymbol(Items.PAPER.getDefaultStack()), null, null, new RecipeSymbol(initMapX2)};
 
         for (int i = 0; i < 4; i++) {
             int x = 13 + 18 * (i % 2) + xOffset;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
index 0bcc236f2..b1736f267 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
@@ -15,7 +15,7 @@ public class HudComponentFireBar
 
     @Override
     public boolean isVisible(Minecraft mc) {
-        return mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.remainingFireTicks > 0;
+        return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.remainingFireTicks > 0;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 34b9ebb2b..0264d808b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -138,7 +138,10 @@ public class HudComponentHotbar
         // Render selector
         hud.drawGuiIcon((x + 4) + (inv.getCurrentItemIndex() % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
 
-        hud.heldItemTooltipElement.updateAndRender(mc, x + 187/2, y - 20);
+        GL11.glPushMatrix();
+        GL11.glTranslatef(0, 0, 1f);
+        hud.heldItemTooltipElement.updateAndRender(mc, x + 5 + 182/2, y - 29);
+        GL11.glPopMatrix();
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index 1edd03465..aac134037 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -130,6 +130,10 @@ public class ScreenOptions
     private void drawPagesListItems(int x, int y, int width, int mouseX, int mouseY) {
         int y2 = y;
         for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+            if (!page.isVisible(this.mc)) {
+                continue;
+            }
+
             String translated = I18n.getInstance().translateKey(page.getTranslationKey());
             int textColor = 0xFF7F7F7F;
             if (page == selectedPage) {
@@ -212,7 +216,15 @@ public class ScreenOptions
     }
 
     private int getTotalPagesListHeight() {
-        return PAGE_BUTTON_HEIGHT * OptionsPageRegistry.getInstance().getPages().size();
+        int acc = 0;
+        for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+            if (!page.isVisible(this.mc)) {
+                continue;
+            }
+            acc++;
+        }
+
+        return PAGE_BUTTON_HEIGHT * acc;
     }
 
     @Override
@@ -468,6 +480,10 @@ public class ScreenOptions
                 pagesListY = top + (bottom - top - pagesListHeight) / 2;
             }
             for(OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+                if (!page.isVisible(this.mc)) {
+                    continue;
+                }
+
                 if (mx >= 0 && mx <= pagesListWidth && my >= pagesListY && my <= pagesListY + PAGE_BUTTON_HEIGHT) {
                     for (OptionsComponent component : selectedPage.getComponents()) {
                         component.onClose();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
index e6f0bd19b..9c1200fc3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
@@ -152,6 +152,9 @@ public class SearchFieldComponent
             return;
         }
         for (OptionsPage page : OptionsPageRegistry.getInstance().getPages()) {
+            if (!page.isVisible(mc)) {
+                continue;
+            }
             OptionsCategory pageCategory = new OptionsCategory(page.getTranslationKey(), page.getIcon());
             boolean hasComponents = false;
             for (OptionsComponent component : page.getComponents()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPage.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPage.java
index 6c4f1d2e3..77be18ae0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPage.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPage.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.options.data;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.options.components.OptionsComponent;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -19,6 +20,10 @@ public class OptionsPage
         this.icon = icon;
     }
 
+    public boolean isVisible(final @NotNull Minecraft mc) {
+        return true;
+    }
+
     public OptionsPage withComponent(OptionsComponent component)
     {
         components.add(component);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPageDebug.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPageDebug.java
new file mode 100644
index 000000000..e0ed7502c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPageDebug.java
@@ -0,0 +1,18 @@
+package net.minecraft.client.gui.options.data;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+
+public class OptionsPageDebug
+    extends OptionsPage
+{
+    public OptionsPageDebug(String translationKey, ItemStack icon) {
+        super(translationKey, icon);
+    }
+
+    @Override
+    public boolean isVisible(@NotNull Minecraft mc) {
+        return mc.gameSettings.developerMode.value;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 70873e586..6e8836a25 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -87,6 +87,7 @@ public abstract class OptionsPages
                 .withComponent(new ToggleableOptionComponent(mc.gameSettings.itemDescriptions))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.hideUndiscoveredItems))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.dynamicCursor))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.musicToasts))
             )
             .withComponent(new OptionsCategory("gui.options.page.general.category.miscellaneous")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.discordRichPresence))
@@ -118,6 +119,7 @@ public abstract class OptionsPages
         AUDIO = register(new OptionsPage("gui.options.page.audio.title", new ItemStack(Items.RECORD_CAT))
             .withComponent(new OptionsCategory("gui.options.page.audio.category.audio")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.subtitles))
+                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.musicFrequency))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.muteOnLostFocus))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.masterVolume))
                 .withComponent(new FloatOptionComponent(mc.gameSettings.musicVolume))
@@ -313,7 +315,7 @@ public abstract class OptionsPages
         SEARCH = register(new OptionsPage("gui.options.page.search.title", new ItemStack(Blocks.GLASS))
             .withComponent(new SearchFieldComponent())
         );
-        DEBUG = new OptionsPage("gui.options.page.debug.title", Blocks.BEDROCK.getDefaultStack())
+        DEBUG = register(new OptionsPageDebug("gui.options.page.debug.title", Blocks.BEDROCK.getDefaultStack())
             .withComponent(new OptionsCategory("gui.options.page.debug.category.controls")
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleTextureAtlas))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyToggleDebug))
@@ -434,6 +436,6 @@ public abstract class OptionsPages
                     throw new Error();
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.garbage_collect", System::gc))
-            );
+            ));
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
index 6e25d68db..3b4610a6d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
@@ -32,7 +32,7 @@ public class AchievementToast implements IToastable {
     }
 
     @Override
-    public int nameColor(long runtime) {
+    public int titleColor(long runtime) {
         return 0xffffff00;
     }
 
@@ -42,7 +42,7 @@ public class AchievementToast implements IToastable {
     }
 
     @Override
-    public int descriptionColor(long runtime) {
+    public int messageColor(long runtime) {
         return 0xffffffff;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
index dce1e1dbe..8ff9ba60e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/GuiElementToastsHud.java
@@ -168,10 +168,10 @@ public class GuiElementToastsHud extends Gui {
 
         drawGuiIcon(x, y, TOAST_WIDTH, TOAST_HEIGHT, TextureRegistry.getTexture(toast.getTexture(duration)));
         if(toast.messageOnly(duration)) {
-            drawStringConstrained(mc.font, toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
+            drawStringConstrained(mc.font, toast.getMessage(duration), x + 30, y + 7, 120, toast.messageColor(duration));
         } else {
-            drawStringNoShadow(mc.font, toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
-            drawStringNoShadow(mc.font, toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
+            drawStringNoShadow(mc.font, toast.getTitle(duration), x + 30, y + 7, toast.titleColor(duration));
+            drawStringNoShadow(mc.font, toast.getMessage(duration), x + 30, y + 18, toast.messageColor(duration));
         }
 
         GL11.glDepthMask(true);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/IToastable.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/IToastable.java
index 48ee651b1..4574ff953 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/IToastable.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/IToastable.java
@@ -9,11 +9,11 @@ public interface IToastable {
 
     String getTitle(long runtime);
 
-    int nameColor(long runtime);
+    int titleColor(long runtime);
 
     String getMessage(long runtime);
 
-    int descriptionColor(long runtime);
+    int messageColor(long runtime);
 
     double getAnimationProgress(long runtime);
 
